<?php

namespace App\Http\Requests\Admin;

use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;

class ProductRequest extends FormRequest
{

    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        if (! Auth::check()) {
            return false;
        }
        if(in_array(Auth::user()->role, ['super_admin', 'admin']))
        {
            return true;
        }

        if(Auth::user()->hasModule('menu'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules=[
            'image'=>'required',
            'items.*.image'=>'required',
        ];

        foreach (languages() as $lang) {
            $lang_rules=[
                'name_'.$lang->local=> 'required|max:50',
                'description_'.$lang->local=> 'required|max:100',
                'items.*.name_'.$lang->local=>'required|max:50',
            ];
            $rules= array_merge($rules, $lang_rules);
        }

        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {

        $field = metaFields('menu');
        $attributes=[
            'image' => __('menu.image'),
        ];

        foreach (languages() as $lang) {
            $lang_attributes=[
                'name_'.$lang->local=>  __('menu.name') .' '.$lang->local,
                'description_'.$lang->local=>  __('menu.description') .' '.$lang->local,
            ];
            $attributes= array_merge($attributes, $lang_attributes);
        }

        $items = request('items');
        if($items)
        {
            $serial = 1;
            foreach($items as $key=>$row)
            {

                $attribute = [
                    'items.' . $key . '.image'  => __('menu.item').' '. __('menu.icon') . ' ' . $serial,
                ];
                $attributes = array_merge($attributes, $attribute);
                foreach (languages() as $lang)
                {
                    $lang_attributes = [
                        'items.' . $key . '.name_' . $lang->local => __('menu.item').' '. __('menu.name') . ' ' . $lang->local . ' ' . $serial,
                    ];
                    $attributes = array_merge($attributes, $lang_attributes);
                }
                $serial += 1;
            }
        }


        return $attributes;
    }


    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests

        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
